package com.codigoparallevar.minicards.types;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Path;

public class Wire implements Moveable, Drawable {
    private final OutputConnector _dropper;
    private final int _xinit;
    private final int _yinit;
    private int _xend;
    private int _yend;
    private final static int _pathRunWay = 100;

    public Wire(OutputConnector dropper, int xInit, int yInit) {
        super();
        _dropper = dropper;
        _xinit = xInit;
        _yinit = yInit;

        _xend = xInit;
        _yend = yInit;
    }

    @Override
    public void move(int x, int y) {
        _xend = x;
        _yend = y;
    }

    @Override
    public void drop(int x, int y) {
        _dropper.drop(this);
    }

    @Override
    public void draw(Canvas canvas, boolean devMode) {
        final Path samplePath = new Path();

        samplePath.moveTo(_xinit, _yinit);
        samplePath.cubicTo(
                _xinit + _pathRunWay, _yinit,
                _xend - _pathRunWay, _yend,
                _xend, _yend);

        Paint pathPaint = new Paint(Paint.ANTI_ALIAS_FLAG);
        pathPaint.setColor(Color.GREEN);
        pathPaint.setStrokeWidth(5.0f);
        pathPaint.setStrokeCap(Paint.Cap.ROUND);
        pathPaint.setStyle(Paint.Style.STROKE);

        canvas.drawPath(samplePath, pathPaint);
    }
}
